/*
 * i-Count
 *
 * count.java
 *
 * Copyright (C) 1996-2006 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

import com.nttdocomo.ui.*;
import java.io.*;
import java.util.*;
import javax.microedition.io.*;

/*
 * C
 */
public class count extends IApplication
{
	static int hs = 0;			// Hi-Score

	public void start()
	{
		// Cʕ\
		Display.setCurrent(new scr());
	}
}

/*
 * C
 */
class scr extends Canvas
{
	private int srnd = 0;			// Select round
	private int vrnd = 0;			// View round
	private int key = 0;

	private boolean input = false;		// Input mode
	private int type = 0;			// View type
	private int sel = 0;			// Select item

	private Vector in_cnt;			// Input score
	private Vector sc_cnt;			// score
	private int rnd_cnt = 0;		// Current round

	private int[] l_idx;			// Line index
	private Font g_fnt;			// Font

	private ShortTimer kt;			// Key Repeat Timer

	static final int TYPE_COUNT = 0;
	static final int TYPE_MENU = 1;
	static final int TYPE_STATS = 2;

	public scr()
	{
		int i, j;

		kt = ShortTimer.getShortTimer(this, 1, 100, false);

		// `̏
		l_idx = new int[13];
		i = (getWidth() * 100) / 12;
		for (j = 0; j < 13; j++) {
			l_idx[j] = i * j / 100;
		}
		l_idx[12]--;

		// tHg
		g_fnt = Font.getFont(Font.FACE_SYSTEM | Font.SIZE_LARGE | Font.STYLE_PLAIN);
		if (g_fnt.stringWidth("88888888888888") > getWidth()) {
			g_fnt = Font.getFont(Font.FACE_SYSTEM | Font.SIZE_MEDIUM | Font.STYLE_PLAIN);
			if (g_fnt.stringWidth("88888888888888") > getWidth()) {
				g_fnt = Font.getFont(Font.FACE_SYSTEM | Font.SIZE_SMALL | Font.STYLE_PLAIN);
			}
		}
		setBackground(Graphics.getColorOfName(Graphics.WHITE));

		type = TYPE_COUNT;
		
		in_cnt = new Vector();
		sc_cnt = new Vector();
		rnd_cnt = 0;

		init_game();
		init_button();
	}

	public void processEvent(int nType, int nParm)
	{
		Dialog d;
		
		if (nType == Display.TIMER_EXPIRED_EVENT && nParm == 1) {
			// L[s[gp^C}[
			int i;
			for (i = Display.KEY_LEFT; i <= Display.KEY_DOWN && ((getKeypadState() >> i) & 0x1) != 1; i++);
			if (i > Display.KEY_DOWN) {
				key = 0;
				return;
			}
			if (key < 4) {
				key++;
				kt.stop();
				kt.start();
				return;
			}
			processEvent(Display.KEY_PRESSED_EVENT, i);
			return;
		}
		if (nType == Display.KEY_PRESSED_EVENT && nParm >= Display.KEY_LEFT && nParm <= Display.KEY_DOWN) {
			// L[s[gJn
			kt.stop();
			kt.start();
		}

		switch (type) {
		case TYPE_COUNT:
			if (nType == Display.KEY_PRESSED_EVENT) {
				if (nParm >= Display.KEY_0 && nParm <= Display.KEY_9) {
					// XRAݒ
					if (input == true) {
						vset(in_cnt, srnd, vget(in_cnt, srnd) * 10 + (nParm - Display.KEY_0));
						if (vget(in_cnt, srnd) >= 1000) {
							vset(in_cnt, srnd,
								vget(in_cnt, srnd) - vget(in_cnt, srnd) / 1000 * 1000);
						}
					} else {
						vset(in_cnt, srnd, nParm - Display.KEY_0);
						input = true;
					}
					repaint();
				} else {
					switch (nParm) {
					case Display.KEY_DOWN:
						if (input == true) {
							set_score_cnt();
						}
						srnd++;
						if (srnd >= rnd_cnt) srnd = rnd_cnt;
						repaint();
						break;

					case Display.KEY_UP:
						if (input == true) {
							set_score_cnt();
						}
						srnd--;
						if (srnd < 0) srnd = 0;
						repaint();
						break;

					case Display.KEY_SELECT:
						// XRAm
						if (srnd == rnd_cnt && input == false) {
							repaint();
							break;
						}
						if (set_score_cnt() == false) {
							repaint();
							break;
						}
						srnd++;
						if (srnd >= rnd_cnt) srnd = rnd_cnt;
						repaint();
						break;
						
					case Display.KEY_POUND:
						// }CiXl
						vset(in_cnt, srnd, vget(in_cnt, srnd) * -1);
						processEvent(Display.KEY_PRESSED_EVENT, Display.KEY_SELECT);
						break;
					}
				}

			} else if (nType == Display.KEY_RELEASED_EVENT) {
				switch (nParm) {
				case Display.KEY_SELECT:
					break;

				case Display.KEY_ASTERISK:
					// vC[
					setSoftLabel(Frame.SOFT_KEY_1, null);
					setSoftLabel(Frame.SOFT_KEY_2, "߂");
					type = TYPE_STATS;
					sel = 0;
					repaint();
					break;

				case Display.KEY_SOFT2:
					// j[
					setSoftLabel(Frame.SOFT_KEY_1, null);
					setSoftLabel(Frame.SOFT_KEY_2, "߂");
					type = TYPE_MENU;
					sel = 0;
					repaint();
					break;
				}
			}
			break;

		case TYPE_MENU:
			// j[
			if (nType == Display.KEY_RELEASED_EVENT) {
				switch (nParm) {
				case Display.KEY_DOWN:
					sel++;
					if (sel > 2) sel = 0;
					repaint();
					break;

				case Display.KEY_UP:
					sel--;
					if (sel < 0) sel = 2;
					repaint();
					break;

				case Display.KEY_SELECT:
					processEvent(Display.KEY_RELEASED_EVENT, Display.KEY_0 + sel + 1);
					break;

				case Display.KEY_1:
					// X^bc
					type = TYPE_COUNT;
					processEvent(Display.KEY_RELEASED_EVENT, Display.KEY_ASTERISK);
					break;

				case Display.KEY_2:
					// NA
					d = new Dialog(Dialog.DIALOG_YESNO, "mF");
					d.setText("XRANA܂H");
					if (d.show() == Dialog.BUTTON_NO) {
						break;
					}
					type = TYPE_COUNT;
					in_cnt = new Vector();
					sc_cnt = new Vector();
					rnd_cnt = 0;

					init_game();
					init_button();
					repaint();
					break;

				case Display.KEY_3:
					// TOPɖ߂
					d = new Dialog(Dialog.DIALOG_YESNO, "mF");
					d.setText("Q[I܂H");
					if (d.show() == Dialog.BUTTON_NO) {
						break;
					}
					// I
					IApplication.getCurrentApp().terminate();
					return;

				case Display.KEY_SOFT2:
					// ߂
					type = TYPE_COUNT;
					init_button();
					repaint();
					break;
				}
			}
			break;

		case TYPE_STATS:
			// X^bc
			if (nType == Display.KEY_RELEASED_EVENT) {
				switch (nParm) {
				case Display.KEY_ASTERISK:
				case Display.KEY_SOFT2:
					// ߂
					type = TYPE_COUNT;
					init_button();
					repaint();
					break;
				}
			}
		}
	}

	public void paint(Graphics g)
	{
		String s;
		int i, j, h;
		int v = 0;

		g.lock();
		g.clearRect(0, 0, getWidth(), getHeight());
		g.setFont(g_fnt);

		// \Jnʒu̎擾
		if (srnd < vrnd) {
			vrnd = srnd;
		} else {
			h = 1;
			i = (getHeight() - h) / (g_fnt.getHeight() + 5);
			i = (i * (g_fnt.getHeight() + 5) <= getHeight() - h) ? i - 1 : i - 2;
			if (i + vrnd < srnd) {
				vrnd = srnd - i;
				if (vrnd < 0) vrnd = 0;
			}
		}
		h = 0;

		switch (type) {
		case TYPE_COUNT:
			// Count
			g.drawLine(0, h, getWidth(), h);
			h++;

			// X[wi̓hԂ
			g.setColor(g.getColorOfName(g.SILVER));
			g.fillRect(0, h, l_idx[3], getHeight());

			// ؂̕`
			g.setColor(g.getColorOfName(g.BLACK));
			g.drawLine(0, h, 0, getHeight());
			g.drawLine(l_idx[3], h, l_idx[3], getHeight());
			g.drawLine(l_idx[7], h, l_idx[7], getHeight());
			g.drawLine(l_idx[12], h, l_idx[12], getHeight());

			// ꗗ̕`
			for (i = vrnd; h < getHeight(); i++) {
				if (i == srnd) {
					// I
					g.setColor(g.getColorOfName(g.BLUE));
					g.fillRect(l_idx[3] + 1, h, l_idx[7] - l_idx[3] - 1, g_fnt.getHeight() + 4);
				}
				h += 2;

				// X[
				s = "" + (i + 1);
				g.setColor(g.getColorOfName(g.BLACK));
				g.drawString(s, 0 + ((l_idx[3] - 0) - g_fnt.stringWidth(s)) / 2, h + g_fnt.getAscent());

				// Fݒ
				if (i == srnd) {
					g.setColor(g.getColorOfName(g.WHITE));
				} else {
					g.setColor(g.getColorOfName(g.BLACK));
				}
				if (i == rnd_cnt && i == srnd && input == true) {
					// Jgʒu
					s = "" + vget(in_cnt, i);
					g.drawString(s, l_idx[3] + ((l_idx[7] - l_idx[3]) - g_fnt.stringWidth(s)) / 2, h + g_fnt.getAscent());
				} else if (i < rnd_cnt) {
					// ͍ς݂̃XRA
					// XRA`
					s = "" + vget(in_cnt, i);
					g.drawString(s, l_idx[3] + ((l_idx[7] - l_idx[3]) - g_fnt.stringWidth(s)) / 2, h + g_fnt.getAscent());
					s = "" + vget(sc_cnt, i);
					g.setColor(g.getColorOfName(g.BLACK));
					g.drawString(s, l_idx[7] + ((l_idx[12] - l_idx[7]) - g_fnt.stringWidth(s)) / 2, h + g_fnt.getAscent());
 				}
				h += g_fnt.getHeight() + 2;

				g.setColor(g.getColorOfName(g.BLACK));
				g.drawLine(0, h, getWidth(), h);
				h++;
			}
			break;

		case TYPE_MENU:
			// j[
			// wb_̕`
			g.setColor(g.getColorOfName(g.BLACK));
			h++;
			g.drawString("j[", 1, h + g_fnt.getAscent());
			h += g_fnt.getHeight() + 1;
			g.drawLine(0, h, getWidth(), h);
			h++;

			// j[̕`
			for (i = 0; i < 3; i++) {
				if (sel == i) {
					// I
					g.setColor(g.getColorOfName(g.BLUE));
					g.fillRect(0, h, getWidth(), g_fnt.getHeight() + 2);
					g.setColor(g.getColorOfName(g.WHITE));
				} else {
					g.setColor(g.getColorOfName(g.BLACK));
				}
				s = "";
				switch(i) {
				case 0: s = "\ue6e2 X^bc(*)"; break;
				case 1: s = "\ue6e3 NA"; break;
				case 2: s = "\ue6e4 I"; break;
				}
				h++;
				g.drawString(s, 1, h + g_fnt.getAscent());
				h += g_fnt.getHeight() + 1;
			}
			g.setColor(g.getColorOfName(g.BLACK));
			g.drawLine(0, h, getWidth(), h);
			break;

		case TYPE_STATS:
			// X^bc
			int n, m, l = 0;

			j = 0;
			for (i = 0; i < rnd_cnt; i++) {
				j = j + vget(in_cnt, i);
			}
			s = "Score: " + j;
			h++;
			g.drawString(s, 1, h + g_fnt.getAscent());
			h += g_fnt.getHeight() + 1;

			s = "Round: " + rnd_cnt;
			h++;
			g.drawString(s, 1, h + g_fnt.getAscent());
			h += g_fnt.getHeight() + 1;

			if (rnd_cnt <= 0) {
				n = 0;
				s = "00";
			} else {
				if (j < 0) {
					j *= -1;
					l = -1;
				}
				n = j / rnd_cnt;
				m = j * 1000 / rnd_cnt;
				m -= m / 1000 * 1000;
				m = (m + 5) / 10;
				if (m < 10) {
					s = "0" + m;
				} else {
					s = "" + m;
				}
			}
			if (l < 0) {
				g.drawString("Avg  : -" + n + "." + s, 1, h + g_fnt.getAscent());
			} else {
				g.drawString("Avg  : " + n + "." + s, 1, h + g_fnt.getAscent());
			}
			h += g_fnt.getHeight() + 1;

			if (j <= (rnd_cnt * 3)) {
				if (rnd_cnt <= 0) {
					n = 0;
					s = "00";
				} else {
					if (j < 0) {
						j *= -1;
						l = -1;
					}
					n = (j * 100) / (rnd_cnt * 3);
					m = (j * 100) * 1000 / (rnd_cnt * 3);
					m -= m / 1000 * 1000;
					m = (m + 5) / 10;
					if (m < 10) {
						s = "0" + m;
					} else {
						s = "" + m;
					}
				}
				if (l < 0) {
					g.drawString("Rate : -" + n + "." + s + "%", 1, h + g_fnt.getAscent());
				} else {
					g.drawString("Rate : " + n + "." + s + "%", 1, h + g_fnt.getAscent());
				}
				h += g_fnt.getHeight() + 1;
			}
		}
		g.unlock(true);
	}

	/** Vector̒g擾 */
	private int vget(Vector v, int i)
	{
		Integer ret;

		if (v.size() <= i) {
			return 0;
		}
		ret = (Integer)v.elementAt(i);
		return ret.intValue();
	}

	/** Vectorɒlݒ */
	private void vset(Vector v, int i, int n)
	{
		int j;

		if (v.size() <= i) {
			for (j = v.size(); j < i; j++) {
				v.addElement(new Integer(0));
			}
			v.addElement(new Integer(n));
		} else {
			v.setElementAt(new Integer(n), i);
		}
	}

	/*
	 * {^̏
	 */
	private void init_button()
	{
		switch (type) {
		case TYPE_COUNT:
			setSoftLabel(Frame.SOFT_KEY_1, null);
			setSoftLabel(Frame.SOFT_KEY_2, "Menu");
			break;
		}
	}

	/*
	 * Q[̏
	 */
	private void init_game()
	{
		// Q[̏
		vrnd = 0;
		input = false;

		switch (type) {
		case TYPE_COUNT:
			srnd = rnd_cnt;
			break;
		}
	}

	/*
	 * CountXRAݒ
	 */
	private boolean set_score_cnt()
	{
		int i;

		vset(sc_cnt, 0, vget(in_cnt, 0));
		for (i = 1; i <= rnd_cnt; i++) {
			vset(sc_cnt, i, vget(sc_cnt, i - 1) + vget(in_cnt, i));
		}
		if (srnd == rnd_cnt && input == true) {
			rnd_cnt++;
		}
		input = false;
		return true;
	}
}
/* End of source */
